/*
	*******************************************************
	* "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
	*******************************************************
	*                                                     *
	* Code source correspond aux exemples traits dans l' *
	* ouvrage.                                            *
	*                                                     *
	* Environment : Borland Developer Studio 2006         *
	* Test sur la version Architecte Franaise patch 1   *
	*                                                     *
	* Copyright   : Olivier Dahan                         *
	*                                                     *
	* Aucune copie, distribution, publication sans l'     *
	* accord exprs de l'auteur.                          *
	* Le prsent code source est fourni "tel quel"       *
	* titre d'illustration des propos techniques du livre *
	* Aucune garantie de fonctionnement ou d'adaptation   *
	* n'est fournie, aucune maintenance corrective ou     *
	* volutive ne sera fournie sur le prsent code.      *
	* Vous utilisez ce code sous votre seule responsabi-  *
	* lit et  vos risques et prils. L'auteur ne serait *
	* tre tenu pour responsable d'ventuelles pertes de  *
	* donnes ou de jouissance qui pourraient rsulter de *
	* l'utilisation du prsent code.                      *
	*                                                     *
	* Contact          : BDSLivre@e-naxos.com             *
	* Site de l'auteur : http://www.e-naxos.com           *
	*******************************************************

*/


using System;

namespace OD.DotNet.CS.Delegates
{
	delegate void MonDelegate(int i);

	class Demo
	{
		static void Main(string[] args)
		{
		 MonDelegate md = null;
		 md += new MonDelegate(FonctionDeDelegation);
		 md += new MonDelegate(FonctionDeDelegation2);

		 AccepteUnDelegate( md );

		 Console.ReadLine(); // pause
		}

		public static void AccepteUnDelegate(MonDelegate fonction)
		{ fonction(56); }

		public static void FonctionDeDelegation(int i)
		{ Console.WriteLine("Le paramtre vaut {0}",i); }

		public static void FonctionDeDelegation2(int i)
		{ Console.WriteLine("La moiti du paramtre {0} vaut {1}",i,i/2); }
	}
}
