/*
	*******************************************************
	* "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
	*******************************************************
	*                                                     *
	* Code source correspond aux exemples traits dans l' *
	* ouvrage.                                            *
	*                                                     *
	* Environment : Borland Developer Studio 2006         *
	* Test sur la version Architecte Franaise patch 1   *
	*                                                     *
	* Copyright   : Olivier Dahan                         *
	*                                                     *
	* Aucune copie, distribution, publication sans l'     *
	* accord exprs de l'auteur.                          *
	* Le prsent code source est fourni "tel quel"       *
	* titre d'illustration des propos techniques du livre *
	* Aucune garantie de fonctionnement ou d'adaptation   *
	* n'est fournie, aucune maintenance corrective ou     *
	* volutive ne sera fournie sur le prsent code.      *
	* Vous utilisez ce code sous votre seule responsabi-  *
	* lit et  vos risques et prils. L'auteur ne serait *
	* tre tenu pour responsable d'ventuelles pertes de  *
	* donnes ou de jouissance qui pourraient rsulter de *
	* l'utilisation du prsent code.                      *
	*                                                     *
	* Contact          : BDSLivre@e-naxos.com             *
	* Site de l'auteur : http://www.e-naxos.com           *
	*******************************************************

*/

using System;


namespace OD.DotNet.CS.Console.Enum
{
	class Class
	{
		public enum JourSemaine
			{ Lundi, Mardi, Mercredi=55, Jeudi, Vendredi, Samedi, Dimanche }

		static void Main(string[] args)
		{
		 JourSemaine s;
		 s = JourSemaine.Lundi;
		 System.Console.WriteLine(s);
		 System.Console.ReadLine();
		 s = JourSemaine.Mercredi;
		 string str = s.ToString();
		 System.Console.WriteLine(str);
		 // affiche les valeurs (voir Mercredi = 55)
		 foreach (int j in System.Enum.GetValues(typeof(JourSemaine)))
		  System.Console.WriteLine(j);
		 // affiche les noms des constantes
		 foreach (string j in System.Enum.GetNames(typeof(JourSemaine)))
		  System.Console.WriteLine(j);

		 System.Console.ReadLine();
		}
	}
}
