{
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

}


program OD.DotNet.Delphi.&Record;

{$APPTYPE CONSOLE}

type
 Point = Record
       x,y : integer;
       Constructor Point(p1,p2:integer);
       procedure init(p1,p2:integer);
       end;

Constructor Point.Point(p1,p2:integer);
begin
 inherited create; // accept mais inutile dans un record
 x:=p1;
 y:=p2;
end;

Procedure Point.init(p1,p2:integer);
begin
 x:=p1;
 y:=p2;
end;

var monPoint, votrePoint, unAutre : Point;

begin
 votrePoint := Point.Point(5,15); // appel du constructeur
 unAutre.init(20,50); // sans constructeur
 // monPoint n'est pas initialis du tout

 Console.Write('mon point : ');
 Console.WriteLine('x = {0}, y = {0}',[monPoint.x,monPoint.y]);

 Console.Write('votre point : ');
 Console.WriteLine('x = {0}, y = {0}',[votrePoint.x,votrePoint.y]);

 Console.Write('autre point : ');
 Console.WriteLine('x = {0}, y = {0}',[unAutre.x,unAutre.y]);

 Console.ReadLine; // pause
end.
